###############################  COPYRIGHT ##################################
#                                                                           #
#   Copyright (c) 2009-2021 TopLinker Co.,Ltd. (http://www.topibd.com)      #
#                           ALL RIGHTS RESERVED                             #
#                                                                           #
#   The entire contents of this file is protected by copyright law and      #
#   international treaties. Unauthorized reproduction, reverse-engineering  #
#   and distribution of all or any portion of the code contained in this    #
#   file is strictly prohibited and may result in severe civil and          #
#   criminal penalties and will be prosecuted to the maximum extent         #
#   possible under the law.                                                 #
#                                                                           #
#   RESTRICTIONS                                                            #
#                                                                           #
#   THE SOURCE CODE CONTAINED WITHIN THIS FILE AND ALL RELATED              #
#   FILES OR ANY PORTION OF ITS CONTENTS SHALL AT NO TIME BE                #
#   COPIED, TRANSFERRED, SOLD, DISTRIBUTED, OR OTHERWISE MADE               #
#   AVAILABLE TO OTHER INDIVIDUALS WITHOUT WRITTEN CONSENT                  #
#   AND PERMISSION FROM DEVELOPER MACHINES                                  #
#                                                                           #
#   CONSULT THE END USER LICENSE AGREEMENT FOR INFORMATION ON               #
#   ADDITIONAL RESTRICTIONS.                                                #
#                                                                           #
#############################################################################

TARGET = $$qtLibraryTarget(topikm6-topsys-plugin)

QT += core  sql widgets script network xml scripttools printsupport
win32 {
    QT += axcontainer
}

TEMPLATE = lib

CONFIG += plugin

SOURCES += \
    topsysplugin.cpp

HEADERS += \
    topsysplugin.h

LIB_LIST = tsec tbaseutil tdatabaseutil twidget topcore toputil tchart texcelxs
win32 {
    LIB_LIST += tole
}

win32 {
    LIBS += -ldbghelp
    LIBS += -luser32
}

include(sysmainwindow/sysmainwindow.pri)
include(sysusermgt/sysusermgt.pri)
include(sysusermgtv2/sysusermgtv2.pri)
include(sysrolemgt/sysrolemgt.pri)
include(sysmoduleconfmgt/sysmoduleconfmgt.pri)
include(sysenumlistmgt/sysenumlistmgt.pri)
include(syscommugroupmgt/syscommugroupmgt.pri)
include(syslogconsole/syslogconsole.pri)
include(sysmacroconsole/sysmacroconsole.pri)
include(sysconfigmgt/sysconfigmgt.pri)
include(sysmainwindowv2/sysmainwindowv2.pri)
include(syscontactmgt/syscontactmgt.pri)
include(syschartdevelopermgt/syschartdevelopermgt.pri)
include(syschartnavigationmgt/syschartnavigationmgt.pri)

DIST_DIR = $$PWD/../../../dist
include(../shared/shared.pri)

INCLUDEPATH += ../lib

LIBS += -L$$DESTDIR
win32 {
    LIBS += -L$${DESTDIR}/plugins
}
win32{
    DESTDIR = $${DESTDIR}/plugins
}

TRANSLATIONS += topikm6_topsys_zhcn.ts \
                topikm6_topsys_en.ts   \
                topikm6_topsys_zhtw.ts

QM_LIST = $$PWD/*.qm

DEST_LANGUAGE_PATH = $$system_path($${TOPIKM_SDKPATH}/language)
!exists($${DEST_LANGUAGE_PATH}) {
    mkpath($${DEST_LANGUAGE_PATH})
}

for(qm, QM_LIST) {
    win32{
        system(copy $$system_path($${qm}) $${DEST_LANGUAGE_PATH})
    }
    else{
        system(cp $$system_path($${qm}) $${DEST_LANGUAGE_PATH})
    }
}

# Version
CONFIG += skip_target_version_ext
VERSION = 6.2.25.0
QMAKE_TARGET_PRODUCT = topikm6-topsys
QMAKE_TARGET_COMPANY = TopLinker Co.,Ltd.
QMAKE_TARGET_COPYRIGHT = Copyright(C) 2021 TopLinker
