﻿#include "sysusermgtthreadv2.h"
#include <topcore/topcore.h>
#include <tbaseutil/tdataresponse.h>
#include <tbaseutil/tdataparse.h>
#include <tdatabaseutil/tsqlconnectionpoolv2.h>
#include <tdatabaseutil/tsqlqueryv2.h>
#include <tdatabaseutil/tsqlselectorv2.h>

SysUserMgtThreadV2::SysUserMgtThreadV2(QObject *iParent)
    : TopClassThreadAbs(iParent)
{

}

SysUserMgtThreadV2::~SysUserMgtThreadV2()
{

}

void SysUserMgtThreadV2::run()
{
    if (invokeName() == "DELETE_USER") {
        deleteUser();
    }
}

void SysUserMgtThreadV2::deleteUser()
{
    TDataResponse dataRes;
    TSqlQueryV2 sqlQuery(T_SQLCNT_POOL->getSqlDatabase());
    sqlQuery.begin();
    try{
        TSqlDeleterV2 sqlDeleter;
        sqlDeleter.setTable("pub_contact");
        // 将传入的值的id与sys_user中的id进行比较，要相等，并且contact_id不能为空，在这种条件下，如果有contcat_id，那么select语句就将它选出来
        sqlDeleter.setWhere(QString("id IN (SELECT contcat_id FROM sys_user WHERE id IN (%1) AND contcat_id IS NOT NULL)")
                            .arg(invokeParameter().toStringList().join(",")));
        // 然后将对应id的那行数据从数据表里删除
        sqlQuery.deleteRow(sqlDeleter);
        if (sqlQuery.lastError().isValid()) {
            throw sqlQuery.lastError();
        }

        sqlDeleter.clear();
        sqlDeleter.setTable("sys_user");
        sqlDeleter.setWhere("id",invokeParameter());
        sqlQuery.deleteRow(sqlDeleter);
        if (sqlQuery.lastError().isValid()) {
            throw sqlQuery.lastError();
        }

        sqlQuery.commit();
        setInvokeResult(dataRes.toVariantMap());
        return;
    } catch (const TError &err) {
        dataRes.setError(err);
    } catch (...) {
        dataRes.setErrText(ttr("Unknow Error!"));
    }
    sqlQuery.rollback();
    setInvokeResult(dataRes.toVariantMap());
}
