﻿#ifndef SYSUSERMGTV2_H
#define SYSUSERMGTV2_H

#include <tbaseutil/tdataresponse.h>
#include <tdatabaseutil/tsqlselectorv2.h>
#include <topcore/topclassabs.h>
#include "sysuserv2.h"

class TPageTool;
class TSearchEntry;
class TTableView;
class TSplitter;
class TopClassTableConf;

class SysUserMgtV2 : public TopClassAbs
{
    Q_OBJECT
public:
    SysUserMgtV2(const QString &iModuleNameStr = QString(""),
                 const QVariantMap &iUrlPars = QVariantMap(),
                 QWidget *iParent = nullptr);
    ~SysUserMgtV2();

public slots:
    void refresh(bool iResetPageBol = true);
    void newItem();
    bool canModify();
    void deleteItem(const QVariantList &iIdLST);
    QStringList selectedNames();
    void changeItem();
    void searchFunc();
    void onSelectionChanged();
    QVariantList selectedItems();
    void onDetailSaved(const QVariant &iUidStr);

private slots:
    void onPageChanged();
    void onDetailChanged();
    void onNaviReset();

private:
    TSqlSelectorV2 getSqlSelector(bool iResetPageBol = true);
    void initTableView();
    void initNaviView();
    void fillTableData(const TDataResponse &iDataRes);
    QString uiloaderWhere();

private:
    QStringList mProductCategoryLst;
    TSplitter *mBodySplitter = nullptr;
    TTableView *mTableView = nullptr;
    TSearchEntry *mSearchEntry = nullptr;
    SysUserV2 *mDetailView = nullptr;
    TPageTool *mPageTool = nullptr;
    TopClassTableConf *mTableConf;
    TUiLoader *mNaviView = nullptr;
    QWidget *mBodyWidget = nullptr;
    QVariantList mSelectedLst;
};

#endif // SYSUSERMGTV2_H
