function func(self) {
    return [
    {
        name: 'tablewidgt',
        type: 'TabWidget',
        property: {stylesheet:"QTabWidget{background-color:red}"},
        pack: { stretch: 1 },
        perfict_width:800,
    
        child: [
            {
                name: 'userinfo_page',
                type: 'VBoxLayout',
                pack: { label: self.ttr("User Information") },
                child: [
                    {
                        type: 'FormGridLayout',
                        child: [
                            {
                                name: 'id',
                                type: 'LineEdit',
                                pack: {label: self.ttr('ID') } ,
                                property: { enabled: false },
                                state: function(obj) {
                                    return "Hide";
                                }
                            },
                            {
                                name: 'username',
                                type: 'LineEdit',
                                pack: { label: self.ttr('Login Name') },
                                validate: function (obj, val, title, moment, self) {
                                    if (val.trim() == '') {
                                        return [title + self.ttr(" can not be null"), 'Error'];
                                     } else if (!val.match(new RegExp('^[A-Za-z0-9_]+$'))) {
                                         return [title + self.ttr(" can only contain [A-Za-z0-9]!"), 'Error'];
                                     }
                                 },
                            },
                            {
                                name: 'password',
                                type: 'LineEdit',
                                pack: { label: self.ttr('Password') },
                                property: { echo_mode: 'Password' },
                                state: function(obj,self) {
                                    return 'Hide';
                                 }
                            },
                            {
                                name: 'fullname',
                                type: 'LineEdit',
                                pack: { label: self.ttr('Full Name') },
                                property: {},
                                validate: 'NOTNULL'
                            },
                            {
                                name: 'staffid',
                                type: 'LineEdit',
                                pack: { label: self.ttr('Staff ID') },
                                property: {},
                            },
                            // {
                            //     name: 'contcat_id',
                            //     type: 'LineEdit',
                            //     property: { enabled: false },
                            //     state:  function(obj,self) {
                            //         return 'Hide';
                            //     }
                            // },
                            // {
                            //     name: 'mail',
                            //     type: 'LineEdit',
                            //     pack: { label: self.ttr('Mail') },
                            //     property: {},
                            //     validate: function (obj, val, title, moment) {
                            //         if (val != '') {
                            //             var filter = /^([a-zA-Z0-9_\.\-])+\@(([a-zA-Z0-9\-])+\.)+([a-zA-Z0-9]{2,4})+$/;
                            //             if (!filter.test(val)) {
                            //                 return [self.ttr("invalid mail format"), 'ERROR']
                            //             }
                            //          }
                            //     },
                            // },
                            {
                                name: 'attr_data.remark',
                                type: 'PlainTextEdit',
                                pack: { label: self.ttr('Remark') },
                                property: {
                                    max_row_count: 2
                                }
                            },
                            {
                                name: 'status',
                                type: 'ComboBox',
                                pack: { label: self.ttr('Status') },
                                property: { item_list: TOPENM.enumList("sys-user-status").toComboList() },
                                title: self.ttr('Status'),
                                validate: function (obj, val, title, moment, self) {
                                    if (val.trim() == '') {
                                        return [title + self.ttr(" can not be null"), 'Error'];
                                    }
                                }
                            },
                            {
                                name: 'attr_data.password_validity_control',
                                type: 'CheckBox',
                                title: self.ttr('Password Validity Control'),
                                property: {},
                                pack: { label: self.ttr('Password Validity Control') },
                                callback: function (obj, checked, self) {
                                    if (checked) {
                                        this.setState("attr_data.validity_period", "show");
                                    } else {
                                        this.setState("attr_data.validity_period", "hide");
                                    }
                                },
                                setter: function (obj, value, self) {
                                    if (value === 1 || value == true || value === 'on' || value === 'yes') {
                                        obj.setIntValue(1);
                                        this.setState("attr_data.validity_period", "show");
                                    } else {
                                        obj.setIntValue(0);
                                        this.setState("attr_data.validity_period", "hide");
                                    }
                                },
                                state: function (obj, self) {
                                    if (APP.hasRight("sys-user-password-validity-control")) {
                                        return 'Show';
                                    } else {
                                        return 'Hide';
                                    }
                                }
                            },
                            {
                                name: 'attr_data.validity_period',
                                type: 'IntLineEdit',
                                pack: { label: self.ttr('Validity Period') },
                                property: { min_value: 0 },
                                state: function (obj, self) {
                                    if (APP.hasRight("sys-user-password-validity-control") &&
                                        this.getValue('attr_data.password_validity_control') == 1) {
                                        return 'Show';
                                    } else {
                                        return 'Hide';
                                    }
                                },
                                child: [
                                    {
                                        name: "validity_period_unit",
                                        type: "Label",
                                        property: {
                                            text: "  " + self.ttr('Month') + "  ",
                                            alignment: "HCenter|VCenter",
                                            fixed_height: 26,
                                            stylesheet: "background-color: white;border-left: 1px solid lightgray;"
                                        }
                                    }  
                                ]
                            },
                            {
                                name: 'product_category',
                                type: 'MultiComboBox',
                                title: self.ttr('Product Category'),
                                property: { item_list: TOPENM.enumList("sys-product-category").toComboList(), name_format: 'A,B' },
                                pack: { label: self.ttr('Product Category') },
                                getter : function(obj, self)
                                {
                                    return obj.getData("current_names");
                                },
                                setter: function(obj,value,self){
                                    obj.setData("current_names", value);                                    
                                },
                                state: function(obj, self) {
                                    return 'hide';
                                }
                            },
                            {
                                type: "Stretch"
                            }
                        ]
                    }
                ]
            }
        ]
    },
];
}
                              